#!/usr/bin/env python
#License GPL
#amk.py
#Version 0.2.5
#Author Fabrizio Ruggeri
#Contact: fabrizio.ruggeri@gmail.com

from qt import *
import sys
import os

class AmuleKform(QWidget):
    def __init__(self,parent = None,name = None,fl = 0):
        QWidget.__init__(self,parent,name,fl)

        if not name:
            self.setName("Form1")


        Form1Layout = QGridLayout(self,1,1,11,6,"Form1Layout")

        layout4 = QVBoxLayout(None,0,6,"layout4")

        layout2 = QVBoxLayout(None,0,6,"layout2")

        layout1 = QHBoxLayout(None,0,6,"layout1")

        self.textLabel1 = QLabel(self,"textLabel1")
        layout1.addWidget(self.textLabel1)
        layout2.addLayout(layout1)

        self.listView1 = QListView(self,"listView1")
        self.listView1.addColumn(self.__tr("File Name"))
        self.listView1.addColumn(self.__tr("Ed2k Link"))
        layout2.addWidget(self.listView1)
        layout4.addLayout(layout2)

        layout3 = QHBoxLayout(None,0,6,"layout3")

        self.sendButton = QPushButton(self,"sendButton")
        layout3.addWidget(self.sendButton)
        spacer3 = QSpacerItem(351,20,QSizePolicy.Expanding,QSizePolicy.Minimum)
        layout3.addItem(spacer3)

        self.exitButton = QPushButton(self,"exitButton")
        layout3.addWidget(self.exitButton)
        layout4.addLayout(layout3)

        Form1Layout.addLayout(layout4,0,0)

        self.languageChange()

        self.resize(QSize(698,561).expandedTo(self.minimumSizeHint()))
        self.clearWState(Qt.WState_Polished)

        self.connect(self.exitButton,SIGNAL("clicked()"),self.close)


    def languageChange(self):
        self.setCaption(self.__tr("Form1"))
        self.textLabel1.setText(self.__tr("<b>Extracetd ed2k link<font size=\"+1\"></font></b>"))
        self.listView1.header().setLabel(0,self.__tr("File Name"))
        self.listView1.header().setLabel(1,self.__tr("Ed2k Link"))
        self.sendButton.setText(self.__tr("Send to &aMule"))
        self.sendButton.setAccel(QKeySequence(self.__tr("Alt+A")))
        self.exitButton.setText(self.__tr("E&xit"))
        self.exitButton.setAccel(QKeySequence(self.__tr("Alt+X")))


    def __tr(self,s,c = None):
        return qApp.translate("AmuleKform",s,c)

#Questa classe eredita il form creato col designer
class MyForm(AmuleKform):
	
	def __init__(self):
		AmuleKform.__init__(self)
		self.connect(self.sendButton,SIGNAL('clicked()'), self.sendToMule)
		
	#Aggiungiamo un funzione per inserire elementi nel form che prende due stringhe
	
	def fillListView(self,nome,elink):
		item = QListViewItem(self.listView1,None)
		item.setText(0,nome)
		item.setText(1,elink)
	
	def sendToMule(self):
		f = open (os.path.expanduser('~')+"/.deleteMe")
		try:
			for line in f:
				os.popen('ed2k \"'+line+'\"')				
		finally:
			f.close()



if __name__ == "__main__":
     app = QApplication(sys.argv)
     myf = MyForm()
     
     #questa parte legge il file generato dallo script amulecollection e estrae nome e link
     try:
	     f = open (os.path.expanduser('~')+"/.deleteMe")   #Apre il file creato dallo script
     except IOError:
	     os.popen('kdialog --error \"I can\'t read this collection file\\nCheck if it\'s corrupted\"')
	     quit()
     try:    #Estrae nome del file e link e le aggiunge al form come elementi
	     for link in f: 
		    name = link[link.find("ed2k://|file|")+13:link.find("|",link.find("ed2k://|file|")+13)]
		    myf.fillListView(name,link)
     finally:
			f.close()
			
     myf.show()
     app.setMainWidget(myf)
     app.exec_loop()